import { Form } from '../../e2elib/lib/src/pageobjects/form.component';
import { DialogUnit } from '../dialogs/dialog.unit';
import { ListSOP } from '../../libappsop/listsop';

export class FormEntity extends Form {
  public listEntity = new ListEntity();

  public constructor() {
    super('FormEntities');
  }
}

export class ListEntity extends ListSOP<DialogUnit, ListEntityColumn> {
  public static readonly title = 'Units and Stocking Points';

  public constructor() {
    super('FormEntities.ListEntity', new DialogUnit());
  }
}

// List columns
export interface ListEntityColumn {
  Name?: string;
  'Capacity type'?: string;
}

// List Context Menu Items
const listEntityContextMenuItem = {
  CreateUnit: { ContextMenu: 'FormEntities.listContextMenu902', Name: 'MenuCreateUnit', Label: 'Create unit' },
  CreateStockingPoint: { ContextMenu: 'FormEntities.listContextMenu902', Name: 'MenuCreateStockingPoint', Label: 'Create stocking point' },
  Edit: { ContextMenu: 'FormEntities.listContextMenu902', Name: 'MenuEdit', Label: 'Edit' },
  Delete: { ContextMenu: 'FormEntities.listContextMenu902', Name: 'MenuDelete', Label: 'Delete' },
};

export { listEntityContextMenuItem as ListEntityContextMenuItem };
